%define           debug_package %{nil}
Name: xymon
Version: 4.3.29
Release: 1%{?dist}
Group: Networking/Daemons
URL: http://xymon.sourceforge.net/
Packager: René Vermare <rene@vermare.net>
Vendor: Dr. Linux, https://repo.vermare.net/yum/
License: GPL
Source: xymon-%{version}.tar.gz
Source1: xymon-init.d
Source2: xymon.logrotate
Source3: xymon-client.init
Source4: xymon-client.default
Source5: xymon-client.logrotate
Source6: xymon-client.service

#Uncomment line below if xymon-server has (reverse) proxy.
Patch1: xymon4329-x_forwarded.patch
Patch2: xymon-client-hostname.patch
Patch3: xymon-logfetch-glibc226.patch
#Patch3: eventlog_sh.patch

Summary: Xymon network monitor
BuildRoot: /tmp/xymon-root
BuildRequires: make 
BuildRequires: pcre-devel
BuildRequires: openssl-devel
%if 0%{?fedora} >= 20
BuildRequires: libtirpc-devel c-ares-devel
%endif
Requires: libtirpc c-ares
#BuildRequires: openssl-devel
#BuildRequires: pcre-devel
#BuildRequires: rrdtool-devel
#BuildRequires: openldap-devel
Conflicts: xymon-client

%description
Xymon (previously known as Hobbit) is a system for monitoring 
your network servers and applications. This package contains 
the server side of the Xymon package.

%package client
Summary: Xymon client reporting data to the Xymon server
Group: Applications/System
Requires: libtirpc c-ares
Conflicts: xymon

%description client
This package contains a client for the Xymon (previously known
as Hobbit) monitor. Clients report data about the local system to 
the monitor, allowing it to check on the status of the system 
load, filesystem utilisation, processes that must be running etc.

%prep
rm -rf $RPM_BUILD_ROOT

%setup
	USEXYMONPING=y \
        ENABLESSL=y \
        ENABLELDAP=y \
        ENABLELDAPSSL=y \
        XYMONUSER=xymon \
        XYMONTOPDIR=/usr/lib/xymon \
        XYMONVAR=/var/lib/xymon \
        XYMONHOSTURL=/xymon \
        CGIDIR=/usr/lib/xymon/cgi-bin \
        XYMONCGIURL=/xymon-cgi \
        SECURECGIDIR=/usr/lib/xymon/cgi-secure \
        SECUREXYMONCGIURL=/xymon-seccgi \
        HTTPDGID=apache \
        XYMONLOGDIR=/var/log/xymon \
        XYMONHOSTNAME=localhost \
        XYMONHOSTIP=127.0.0.1 \
        MANROOT=/usr/share/man \
        INSTALLBINDIR=/usr/lib/xymon/server/bin \
        INSTALLETCDIR=/etc/xymon \
        INSTALLWEBDIR=/etc/xymon/web \
        INSTALLEXTDIR=/usr/lib/xymon/server/ext \
        INSTALLTMPDIR=/var/lib/xymon/tmp \
        INSTALLWWWDIR=/var/lib/xymon/www \
        ./configure

#Uncomment line below if xymon-server has (reverse) proxy.
%patch1 -p1 -b .X_FORWARDED
%patch2 -p1 -b .CLIENT-HOSTNAME
%patch3 -p1 -b .LOGFETCH-GLIBC226
#%patch3 -p1 -b .EVENTLOG1440

%build
	PKGBUILD=1 make

%install
        INSTALLROOT=$RPM_BUILD_ROOT PKGBUILD=1 make install
	mkdir -p $RPM_BUILD_ROOT/etc/init.d
	cp %{SOURCE1} $RPM_BUILD_ROOT/etc/init.d/xymon
	cp %{SOURCE3} $RPM_BUILD_ROOT/etc/init.d/xymon-client
	mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
	cp %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/xymon
	cp %{SOURCE5} $RPM_BUILD_ROOT/etc/logrotate.d/xymon-client
	mkdir -p $RPM_BUILD_ROOT/usr/lib/systemd/system
	cp %{SOURCE6} $RPM_BUILD_ROOT/usr/lib/systemd/system/xymon-client.service
	mkdir -p $RPM_BUILD_ROOT/etc/default
	cp %{SOURCE4} $RPM_BUILD_ROOT/etc/default/xymon-client
	mkdir -p $RPM_BUILD_ROOT/usr/bin
	cd $RPM_BUILD_ROOT/usr/bin && ln -sf ../lib/xymon/server/bin/{xymon,xymoncmd} .
	mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
	mv $RPM_BUILD_ROOT/etc/xymon/xymon-apache.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/
	rmdir $RPM_BUILD_ROOT/usr/lib/xymon/client/tmp
	cd $RPM_BUILD_ROOT/usr/lib/xymon/client && ln -sf /tmp tmp
	rmdir $RPM_BUILD_ROOT/usr/lib/xymon/client/logs
	cd $RPM_BUILD_ROOT/usr/lib/xymon/client && ln -sf ../../../../var/log/xymon logs
	mv $RPM_BUILD_ROOT/usr/lib/xymon/client/etc/xymonclient.cfg /tmp/xymonclient.cfg.$$
	cat /tmp/xymonclient.cfg.$$ | sed -e 's!^XYMSRV=.*!include /var/run/xymon/xymonclient-runtime.cfg!' | grep -v "^XYMSERVERS=" >$RPM_BUILD_ROOT/usr/lib/xymon/client/etc/xymonclient.cfg
	rm /tmp/xymonclient.cfg.$$
	mkdir -p $RPM_BUILD_ROOT/var/run/xymon

%clean
rm -rf $RPM_BUILD_ROOT


%pre
id xymon 1>/dev/null 2>&1
if [ $? -ne 0 ]
then
   groupadd xymon || true
   useradd -g xymon -c "Xymon user" -d /usr/lib/xymon xymon
fi
if [ -e /var/log/xymon/xymonlaunch.pid -a -x /etc/init.d/xymon ]
then
	/etc/init.d/xymon stop || true
fi

%pre client
id xymon 1>/dev/null 2>&1
if [ $? -ne 0 ]
then
   groupadd xymon || true
   useradd -g xymon -c "Xymon user" -d /usr/lib/xymon xymon
fi
if [ -e /var/log/xymon/clientlaunch.pid -a -x /etc/init.d/xymon-client ]
then
	/etc/init.d/xymon-client stop || true
fi


%post

%post client
systemctl daemon-reload &>/dev/null


%preun
if [ -e /var/log/xymon/xymonlaunch.pid -a -x /etc/init.d/xymon ]
then
	/etc/init.d/xymon stop || true
fi

%preun client
if [ -e /var/log/xymon/clientlaunch.pid -a -x /etc/init.d/xymon-client ]
then
	/etc/init.d/xymon-client stop || true
fi


%files
%attr(-, root, root) %doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES
%attr(644, root, root) %doc /usr/share/man/man*/*
%attr(644, root, root) %config /etc/xymon/alerts.cfg
%attr(644, root, root) %config /etc/xymon/*
%attr(644, root, root) %config /etc/httpd/conf.d/xymon-apache.conf
%attr(755, root, root) %dir /etc/xymon 
%attr(755, root, root) %dir /usr/lib/xymon/server/download
%attr(755, root, root) %dir /etc/xymon/web
%attr(755, xymon, xymon) %dir /var/log/xymon
%attr(755, root, root) /etc/init.d/xymon
%attr(644, root, root) /etc/logrotate.d/xymon
%attr(-, root, root) /usr/lib/xymon
%attr(644, root, root) %config /usr/lib/xymon/client/etc/clientlaunch.cfg
%attr(-, root, root) /usr/bin/*
%attr(-, xymon, xymon) /var/lib/xymon
%attr(775, xymon, apache) %dir /var/lib/xymon/www/rep
%attr(775, xymon, apache) %dir /var/lib/xymon/www/snap
%attr(644, root, root) %config /var/lib/xymon/www/menu/xymonmenu-grey.css
%attr(644, root, root) %config /var/lib/xymon/www/menu/xymonmenu-blue.css
%attr(755, xymon, xymon) %dir /usr/lib/xymon/client/ext
%attr(644, root, root) %config /etc/xymon/analysis.cfg
%attr(664, xymon, apache) %config /etc/xymon/critical.cfg
%attr(664, xymon, apache) %config /etc/xymon/critical.cfg.bak
%attr(4750, root, xymon) /usr/lib/xymon/server/bin/xymonping
%attr(750, root, xymon) /usr/lib/xymon/client/bin/logfetch
%attr(750, root, xymon) /usr/lib/xymon/client/bin/clientupdate

%files client
%attr(-, root, root) %doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES
%attr(644, root, root) %config /usr/lib/xymon/client/etc/clientlaunch.cfg
%attr(-, root, root) /usr/lib/xymon/client
%attr(755, root, root) /etc/init.d/xymon-client
%attr(644, root, root) /usr/lib/systemd/system/xymon-client.service
%attr(644, root, root) /etc/logrotate.d/xymon-client
%attr(644, root, root) %config /etc/default/xymon-client
%attr(755, xymon, xymon) %dir /var/log/xymon
%attr(755, xymon, xymon) %dir /usr/lib/xymon/client/ext
%attr(750, root, xymon) /usr/lib/xymon/client/bin/logfetch
%attr(750, root, xymon) /usr/lib/xymon/client/bin/clientupdate
%attr(755, xymon, xymon) %dir /var/run/xymon

%changelog
* Fri Aug 23 2019 René Vermare <rene@Vermare.net> 4.3.29-1
- Initial build from version 4.3.29-1 for armv6l/armv7hl (fc20)

* Tue Apr  2 2019 René Vermare <rene@vermare.net> 4.3.28-4
- Add systemd stop/start script & move xymonclient-runtime.cfg
  to /var/run/xymon

* Thu Feb 28 2019 René Vermare <rene@vermare.net> 4.3.28-3
- Build for FC29 (aarch64) with logrotate in client package.

* Mon Apr 16 2018 René Vermare <rene@vermare.net> 4.3.28-3
- Build for FC27 (armv7hl) with logrotate in client package.

* Mon Mar  5 2018 René Vermare <rene@vermare.net> 4.3.28-3
- Build for FC22 (armv7hl) with logrotate in client package.

* Sat Feb 25 2017 René Vermare <rene@Vermare.nl> 4.3.28-2
- Build for FC22 (armv7hl) to set correct client hostname in runclient.sh
- No rename for /etc/xymon/alerts.cfg and no replace for:
- /usr/lib/xymon/client/etc/clientlaunch.cfg 

* Fri Feb 24 2017 René Vermare <rene@Vermare.nl> 4.3.28-1
- Fix for building on OpenSSL 1.1.0.
- Fix overflow when skipping >2G pending data in logfetch.
- Misc enhancement and bugfixes, see 'Changes' in tarfile.

* Mon Aug 22 2016 René Vermare <rene@Vermare.nl> 4.3.27-3
- Build for RHEL4 (i386) to set 'http_x_forwarded_for' on enable/disable
- and acknowledge page.

* Tue Aug 16 2016 René Vermare <rene@Vermare.nl> 4.3.27-2
- Build for RHEL4 (i386) to set eventlog on 1440 min.
- and 250 events (instead of 240 min. and 100 events).

* Sat Jul 30 2016 René Vermare <rene@Vermare.nl> 4.3.27-1
- Build for FC22 (armv7hl)

* Fri Jul 29 2016 René Vermare <rene@Vermare.nl> 4.3.10-1
- Build for RHEL4 (i386)

* Fri Jul 29 2016 René Vermare <rene@Vermare.nl> 4.3.27-1
- Build for RHEL4 (i386)
